sfcode: to-regex <a href="https://www.npmjs.com/package/to-regex"><img src="https://img.shields.io/npm/v/to-regex.svg?style=flat" alt="NPM version"/></a> <a href="https://npmjs.org/package/to-regex"><img src="https://img.shields.io/npm/dm/to-regex.svg?style=flat" alt="NPM monthly downloads"/></a> <a href="https://npmjs.org/package/to-regex"><img src="https://img.shields.io/npm/dt/to-regex.svg?style=flat" alt="NPM total downloads"/></a> <a href="https://travis-ci.org/jonschlinkert/to-regex"><img src="https://img.shields.io/travis/jonschlinkert/to-regex.svg?style=flat&label=Travis" alt="Linux Build Status"/></a>
to-regex

Contributing

> Generate a regex from a string or array of strings.

Please consider following this project's author, Jon Schlinkert, and consider starring the project to show your :heart: and support.

- Install
- Usage
- Options
  - options.contains
  - options.negate
  - options.nocase
  - options.flags
  - options.cache
  - options.safe
- About
  - Related projects
  - Author
  - License

_(TOC generated by verb using markdown-toc)_

# Install

Install with npm:

$ npm install --save to-regex

# Usage

var toRegex = require('to-regex');
console.log(toRegex('foo'));
//=> /^(?:foo)$/
console.log(toRegex('foo', {negate: true}));
//=> /^(?:(?:(?!^(?:foo)$).)*)$/
console.log(toRegex('foo', {contains: true}));
//=> /(?:foo)/
console.log(toRegex(['foo', 'bar'], {negate: true}));
//=> /^(?:(?:(?!^(?:(?:foo)|(?:bar))$).)*)$/
console.log(toRegex(['foo', 'bar'], {negate: true, contains: true}));
//=> /^(?:(?:(?!(?:(?:foo)|(?:bar))).)*)$/

# Options

## options.contains

Type: `Boolean`

Default: `undefined`

Generate a regex that will match any string that contains the given pattern. By default, regex is strict will only return true for exact matches.

var toRegex = require('to-regex');
console.log(toRegex('foo', {contains: true}));
//=> /(?:foo)/

## options.negate

Type: `Boolean`

Default: `undefined`

Create a regex that will match everything except the given pattern.

var toRegex = require('to-regex');
console.log(toRegex('foo', {negate: true}));
//=> /^(?:(?:(?!^(?:foo)$).)*)$/

## options.nocase

Type: `Boolean`

Default: `undefined`

Adds the `i` flag, to enable case-insensitive matching.

var toRegex = require('to-regex');
console.log(toRegex('foo', {nocase: true}));
//=> /^(?:foo)$/i

Alternatively you can pass the flags you want directly on options.flags.

## options.flags

Type: `String`

Default: `undefined`

Define the flags you want to use on the generated regex.

var toRegex = require('to-regex');
console.log(toRegex('foo', {flags: 'gm'}));
//=> /^(?:foo)$/gm
console.log(toRegex('foo', {flags: 'gmi', nocase: true})); //<= handles redundancy
//=> /^(?:foo)$/gmi

## options.cache

Type: `Boolean`

Default: `true`

Generated regex is cached based on the provided string and options. As a result, runtime compilation only happens once per pattern (as long as options are also the same), which can result in dramatic speed improvements.

This also helps with debugging, since adding options and pattern are added to the generated regex.

Disable caching

toRegex('foo', {cache: false});

## options.safe

Type: `Boolean`

Default: `undefined`

Check the generated regular expression with safe-regex and throw an error if the regex is potentially unsafe.

Examples

console.log(toRegex('(x+x+)+y'));
//=> /^(?:(x+x+)+y)$/
// The following would throw an error
toRegex('(x+x+)+y', {safe: true});

# About

<details>

Pull requests and stars are always welcome. For bugs and feature requests, please create an issue.

</details>

<details>

Running Tests

Running and reviewing unit tests is a great way to get familiarized with a library and its API. You can install dependencies and run tests with the following command:

$ npm install && npm test

</details>

<details>

Building docs

_(This project's readme.md is generated by verb, please don't edit the readme directly. Any changes to the readme must be made in the .verb.md readme template.)_

To generate the readme, run the following command:

$ npm install -g verbose/verb#dev verb-generate-readme && verb

</details>

## Related projects

You might also be interested in these projects:

- has-glob: Returns `true` if an array has a glob pattern. | homepage
- is-glob: Returns `true` if the given string looks like a glob pattern or an extglob pattern… more | homepage
- path-regex: Regular expression for matching the parts of a file path. | homepage
- to-regex-range: Pass two numbers, get a regex-compatible source string for matching ranges. Validated against more than… more | homepage

## Author

Jon Schlinkert

- linkedin/in/jonschlinkert
- github/jonschlinkert
- twitter/jonschlinkert

## License

Copyright © 2018, Jon Schlinkert. Released under the [MIT License](LICENSE).

This file was generated by verb-generate-readme, v0.6.0, on February 24, 2018.